// SearchingDlg.cpp : implementation file
//

#include "stdafx.h"
#include "findhost.h"
#include "SearchingDlg.h"
#include "process.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


typedef struct tagTryInfo {
	char address[128];
	UINT port;
	HWND hWnd;
} TryInfo;

CSocket Socket;
HANDLE hThread=NULL;

void TryOneAddress(void *param);

/////////////////////////////////////////////////////////////////////////////
// CSearchingDlg dialog


CSearchingDlg::CSearchingDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSearchingDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSearchingDlg)
	//}}AFX_DATA_INIT
}


void CSearchingDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSearchingDlg)
	DDX_Control(pDX, IDC_PROGRESS, m_Progress);
	DDX_Control(pDX, IDC_ANIMATE, m_Animate);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSearchingDlg, CDialog)
	//{{AFX_MSG_MAP(CSearchingDlg)
	ON_WM_TIMER()
	ON_MESSAGE(WM_CONNECT_ERR,OnConnectErr)
	ON_MESSAGE(WM_CONNECT_SUC,OnConnectSuc)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSearchingDlg message handlers

BOOL CSearchingDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_Progress.SetRange(0,m_nNumber);
	m_Animate.Open(IDR_AVI);
	m_Animate.Play(0,-1,-1);

	m_nCurIP=m_nBeginIP;
	TryNext();
	SetTimer(1,m_nTime*1000,NULL);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}



void TryOneAddress(void *param)
{
	TryInfo *p=(TryInfo *)param;

	if(Socket.Create()==0)
	{
		PostMessage(p->hWnd,WM_CONNECT_ERR,0,0);
		Socket.Close();
		hThread=NULL;
		return;
	}

	if(Socket.Connect(p->address,p->port)==0)
	{
		Socket.Close();
		PostMessage(p->hWnd,WM_CONNECT_ERR,0,0);
	}
	else
	{
		Socket.Close();
		PostMessage(p->hWnd,WM_CONNECT_SUC,0,0);
	}

	hThread=NULL;
	return;
}

TryInfo Info;

void CSearchingDlg::TryNext()
{

	//prepare the information for searching
	CString address=m_sIP;
	char tmp[10];
	itoa(m_nCurIP,tmp,10);
	address+=tmp;
	strcpy(Info.address,address);
	Info.port=m_nPort;
	Info.hWnd=m_hWnd;

	//set progress information
	wsprintf(tmp,"%d/%d",m_nCurIP-m_nBeginIP,m_nNumber);
	GetDlgItem(IDC_CURNUM)->SetWindowText(tmp);
	m_Progress.SetPos(m_nCurIP-m_nBeginIP);

	//begin a new search
	SetTimer(1,m_nTime*1000,NULL);
	hThread=(HANDLE)_beginthread(TryOneAddress,0,(void *)&Info);
}

void CSearchingDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if(Socket.IsBlocking())
		Socket.CancelBlockingCall();
	CDialog::OnTimer(nIDEvent);
}

LONG CSearchingDlg::OnConnectErr(LONG lParam, UINT wParam)
{
	m_nCurIP++;
	if(m_nCurIP-m_nBeginIP>=m_nNumber)
	{
		EndDialog(1);
	}
	else
	{
		TryNext();
	}

	return 0;
	
}

LONG CSearchingDlg::OnConnectSuc(LONG lParam, UINT wParam)
{
	CString res;
	res=m_sIP;
	char tmp[10];
	itoa(m_nCurIP,tmp,10);
	res+=tmp;
	m_sResult+=res;
	m_sResult+="\r\n";

	m_nCurIP++;
	if(m_nCurIP-m_nBeginIP>=m_nNumber)
	{
		EndDialog(1);
	}
	else
	{
		TryNext();
	}

	return 0;

}

void CSearchingDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	if(Socket.IsBlocking())
	{
		Socket.CancelBlockingCall();
		Socket.Close();
	}

	CDialog::OnCancel();
}
