#include "../PGPICQDefs.h"

#include <pgpUtilities.h>
#include <pgpKeys.h>
#include <pgpEncode.h>
#include <pgpErrors.h>
#include <pgpPFLErrors.h>
#include <pgpUserInterface.h>
#include <pgpMemoryMgr.h>
#include <pgpPubTypes.h>
#include <pgpSDKPrefs.h>
#include <pgpUtilities.h>
#include <pgpKeyServer.h>


// dialog box titles
#define kStrTitleNeutral				"pgpKeys"
#define kStrTitleError					"pgpKeys Error"
#define kStrTitleConfirmation			"pgpKeys Confirmation"
#define kStrFileTitlePublic				"Locate Public Keyring File"
#define kStrFileTitlePrivate			"Locate Private Keyring File"


// key types
#define	kStrKeyTypeNever				"Never"
#define	kStrKeyTypeRSA					"RSA"
#define	kStrKeyTypeDSA					"DH/DSS"
#define	kStrKeyTypeUnknown				"Unknown"
#define	kStrKeyTypeDefpair				"Default key pair"
#define	kStrKeyTypePair					"Key pair"
#define	kStrKeyTypePublic				"Public key"

// prompts
#define kStrKeyTypePromptName			"Your full name is required."
#define kStrKeyTypePromptEmail			"Your email address is required."
#define kStrKeyTypePromptPassShort		"Password must consist of at least 5 characters."
#define kStrKeyTypePromptPassMissmatch	"The confirmation password\ndidn't match the original."
#define kStrBadKeySize					"The size of a new key must be\nin the 1024 - 4096 bit range."
#define kStrKeyTypePromptExpdate		"The epiration date must be\nin the MM/DD/YYYY format."

#define kStrKeyTypePromptCreateFile		"File %s\ndoes not exist. Do you want to create it?"
#define kStrKeyTypePromptLocateFile		"Unable to open specified\npublic and private keyring files.\n\nIn the dialog window that will appear next\nplease locate existing files or specify new ones."
#define kStrKeyTypePromptUploadNow		"Your new key pair\n\n%s\n\nhas been successfuly generated!\n\nDo you want to send the new public key to a key server now?\n(You can do it later at any moment by clicking \"Send to Server\")"
#define kStrKeyTypePromptUploadDone		"The key was successfully uploaded to the server."
#define kStrKeyTypePromptDeleteKeys		"Are you sure you want to delete the following key(s)?\n"
#define kStrKeyTypePromptImport			"About to import the following key(s):\n\n";
#define kStrKeyTypePromptSure			"\nAre you sure?"
#define kStrKeyTypePromptFound			"%d key(s) were found."
#define kStrKeyTypePromptNoInfoFile		"This file does not contain any PGP information."
#define kStrKeyTypePromptNoInfoClip		"The Clipboard does not contain any PGP information."

// errors
#define kStrErrorDefaultKey				"Failed to set new default key!\nMake sure that the key files\nare not used by another application."
#define kStrErrorImport					"Failed to import key(s)!\nMake sure that the key files\nare not used by another application."
#define kStrErrorGenerateKey			"Failed to generate a new key pair!"
#define kStrErrorGenerateSubkey			"Failed to generate a subkey for the new key!"
#define kStrErrorStoreNew				"Failed to store new key pair!\nMake sure that the key files\nare not used by another application."
#define kStrErrorServerConnect			"Failed to connect to the key server!"
#define kStrErrorServerUpload			"Failed to upload to the key server!"
#define kStrErrorServerRejected			"Upload completed, but the server rejected this key."
#define kStrErrorServerQuery			"Query to the key server failed!"

// file filters
#define kStrFileFilterText				"Text Files (*.txt;*.asc)|*.txt;*.asc|Keyring Files (*.pkr;*.skr;*.pgp)|*.pkr;*.skr;*.pgp|All Files (*.*)|*.*||"
#define kStrFileFilterAscii				"ASCII Key File (*.asc)|*.asc|All Files (*.*)|*.*||"
#define kStrFileNameAscii				"Public Keys"
#define kStrFileExtAscii				"asc"
#define kStrFileFilterPublic			"Public Keyring Files (*.pkr; *.pubkr; *.pgp)|*.pkr; *.pubkr; *.pgp|All Files (*.*)|*.*||"
#define kStrFileExtPublic				"pkr"
#define kStrFileNamePublic				"pubring"
#define kStrFileFilterPrivate			"Secret Keyring Files (*.skr; *.prvkr; *.pgp)|*.skr; *.prvkr; *.pgp|All Files (*.*)|*.*||"
#define kStrFileExtPrivate				"skr"
#define kStrFileNamePrivate				"secring"

// list column headers
#define kStrHeaderKeys					"Keys"
#define kStrHeaderUserID				"User ID"
#define kStrHeaderKeyID					"Key ID"
#define kStrHeaderType					"Type"
#define kStrHeaderSize					"Size"
#define kStrHeaderCreated				"Created"
#define kStrHeaderExpires				"Expires"
