// pgpKeysView.h : interface of the CPgpKeysView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_PGPKEYSVIEW_H__D62B75A8_115B_4E93_8153_6C8476A8E02B__INCLUDED_)
#define AFX_PGPKEYSVIEW_H__D62B75A8_115B_4E93_8153_6C8476A8E02B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CPgpKeysView : public CListView
{
protected: // create from serialization only
	CPgpKeysView();
	DECLARE_DYNCREATE(CPgpKeysView)

	CImageList * m_pSmallImageList;

// Attributes
public:
	CPgpKeysDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPgpKeysView)
	protected:
	virtual void OnInitialUpdate(); // called first time after construct
	virtual BOOL OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult);
	//}}AFX_VIRTUAL

// Implementation
public:
	int GetSelected (StringListT *vecSelected);
	int GetSelected (KeyPointerListT *vecSelected);
	void UpdateKeyList();
	virtual ~CPgpKeysView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CPgpKeysView)
	afx_msg void OnFileNewKeypair();
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnEditSelectall();
	afx_msg void OnKeyDelete();
	afx_msg void OnKeyExport();
	afx_msg void OnKeyImport();
	afx_msg void OnKeyProperties();
	afx_msg void OnKeySearch();
	afx_msg void OnKeySendToServer();
	afx_msg void OnHelpOnline();
	afx_msg void OnUpdateKeyProperties(CCmdUI* pCmdUI);
	afx_msg void OnUpdateKeyDelete(CCmdUI* pCmdUI);
	afx_msg void OnUpdateKeyExport(CCmdUI* pCmdUI);
	afx_msg void OnUpdateKeySend(CCmdUI* pCmdUI);
	afx_msg void OnDblclick(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnKeySetDefault();
	afx_msg void OnUpdateKeySetDefault(CCmdUI* pCmdUI);
	afx_msg void OnEditOptions();
	afx_msg void OnUpdateEditSelectall(CCmdUI* pCmdUI);
	afx_msg void OnStartPgpicq();
	afx_msg void OnKeyCopy();
	afx_msg void OnUpdateKeyCopy(CCmdUI* pCmdUI);
	afx_msg void OnKeyPaste();
	afx_msg void OnUpdateKeyPaste(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in pgpKeysView.cpp
inline CPgpKeysDoc* CPgpKeysView::GetDocument()
   { return (CPgpKeysDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PGPKEYSVIEW_H__D62B75A8_115B_4E93_8153_6C8476A8E02B__INCLUDED_)
